/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmeingabe.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StimmeingabefehlerTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String beschreibung;
    public java.lang.String getBeschreibung(){
      return beschreibung;
    }
    protected final de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehlerart fehlerart;
    public de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehlerart getFehlerart(){
      return fehlerart;
    }

  public StimmeingabefehlerTK(
java.lang.String beschreibung
, de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehlerart fehlerart
  ) {
    super();


      this.beschreibung = beschreibung;
      this.fehlerart = fehlerart;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((beschreibung == null) ? 0 : beschreibung.hashCode());
                    result = result + ((fehlerart == null) ? 0 : fehlerart.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StimmeingabefehlerTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StimmeingabefehlerTK other = (StimmeingabefehlerTK) obj;

                if (beschreibung == null) {
          if (other.beschreibung != null) {
            return false;
          }
        } else if (!beschreibung.equals(other.beschreibung)) {
          return false;
        }
                if (fehlerart == null) {
          if (other.fehlerart != null) {
            return false;
          }
        } else if (!fehlerart.equals(other.fehlerart)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StimmeingabefehlerConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmeingabefehlerConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmeingabefehlerConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, beschreibung));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmeingabefehlerConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmeingabefehlerConstants.MESSAGE_KEY_FEHLERART_EINZAHL, fehlerart));
        
        return result;
      }


            @Override
            public String toString() {
            return "StimmeingabefehlerTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"beschreibung="+beschreibung
                            +", fehlerart="+fehlerart
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(StimmeingabefehlerConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL) + "=" + beschreibung
                          + ", " + messages.getMessageForMessageKey(StimmeingabefehlerConstants.MESSAGE_KEY_FEHLERART_EINZAHL) + "=" + fehlerart
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Stimmeingabefehler> java.util.Map<StimmeingabefehlerTK, E> mappeStimmeingabefehlerNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Stimmeingabefehler::getStimmeingabefehlerTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Stimmeingabefehler, StimmeingabefehlerTK> getStimmeingabefehlerToTKFunction() {
                return Stimmeingabefehler::getStimmeingabefehlerTK;
                }

}
